{
   Program_05.Spin

   same as 04_B corrected but using cogs
   but faulty

   Make sure to use F11 (save to EEPROM) not F10 (save to RAM)
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq   = 5_000_000
  RB_TX      = 30
  RB_RX      = 31
  RB_BAUD    = 115200
  Blink_Time = 160_000_000   '2 secs

Var
  byte ReceivedByte, ByteToSend
  Long Stacks[20] 
OBJ
  RB     : "FullDuplexSerial"
PUB Main|x,t
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  dirA[16..23]~~
  cogNew(SetLEDs(@ReceivedByte),@Stacks[0]) 'put method in its own cog
  cogNew(ReadPins(@ByteToSend),@Stacks[10]) 'put method in its own cog
  t := cnt  'init timer
  repeat
     repeat
         x := RB.RXcheck
         if (cnt-t)> Blink_Time
            !outA[23]   'toggle LED
            t := cnt    'reset timer
     until x <> -1  
     ReceivedByte := x
     'Notice there is no more calling of the methods   
     RB.TX(ByteToSend)

Pri SetLEDs(ReceivedByteAddr)
  outA[22..16] := Byte[ReceivedByteAddr]

Pri ReadPins(ByteToSendAddr)
  Byte[ByteToSendAddr] := inA[7..5]  