{
   Program_05_B.Spin
   05 but using PST to check the problem

   Using PP for RB and programming port for PST
   Compile with F10 to upload to RAM.
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq   = 5_000_000
  RB_TX      = 1
  RB_RX      = 0
  RB_BAUD    = 115200
  D_TX       = 30
  D_RX       = 31
  D_BAUD     = 115200
  Blink_Time = 160_000_000   '2 secs

Var
  byte ReceivedByte, ByteToSend
  Long Stacks[100] 
OBJ
  RB     : "FullDuplexSerial"
  D      : "SerialMirror"
PUB Main|x,t
  D.Start(D_RX,D_TX,0,D_BAUD)
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  dirA[16..23]~~
  cogNew(SetLEDs(@ReceivedByte),@Stacks[0])
  cogNew(ReadPins(@ByteToSend),@Stacks[50])
  t := cnt  'init timer
  repeat
     repeat
         x := RB.RXcheck
         if (cnt-t)> Blink_Time       'if timed out
            !outA[23]                 'toggle LED
            t := cnt                  'reset timer
     until x <> -1
     D.Str(string(13,"Received="))
     D.Dec(ReceivedByte)
     D.Str(string("   , Sending="))
     D.Dec(ByteToSend)  
     ReceivedByte := x    
     RB.TX(ByteToSend)

Pri SetLEDs(ReceivedByteAddr)
  outA[22..16] := Byte[ReceivedByteAddr]

Pri ReadPins(ByteToSendAddr)
  Byte[ByteToSendAddr] := inA[7..5]  