{
   Program_08_Set.Spin

   object used by Program_08.Spin
   Sets the LEDs according to received byte   
   
}
CON
  Blinker    = 21
  FlagMask   = %0000_0010

Var
  long Stacks[50]

Obj
  D      : "SerialMirror"
  
PUB Start(ReceivedByte,Rates,Semaphore)
  cogNew(SetLEDs(ReceivedByte,Rates,Semaphore),@Stacks[0])

Pri SetLEDs(ReceivedByte,Rates,Semaphore)|t
  dirA[20..16]~~
  dirA[Blinker]~~
  t := cnt                        'initialize timer
  repeat
     if (cnt-t) => Long[Rates][2] 'blinker time out 
       !outA[Blinker]             'toggle the LED
       t := cnt                   'reset timer
     outA[20..16] := Byte[ReceivedByte]
     if byte[Semaphore][1] & FlagMask      'only output to PST if flagged to do so
        if Not LockSet(byte[Semaphore])    'only send if can acquire the semaphore  
           D.Str(string(13,"Set:"))                                  
           D.Dec(byte[ReceivedByte])
           byte[Semaphore][1] &= !FlagMask  'clear the flag                                  
           LockClr(byte[Semaphore])        'clear the semaphore           