{
   Program_10_Others_simple.Spin
   if a flag is set Executes various commands 
   
}
CON
  Blinker    = 21
  FlagMask   = %0000_0001
  BlinkerScale = 54         ' 2 80_000_000 for NCO counter

Var
  long Stacks[50]

Obj
  D      : "SerialMirror"
  
PUB Start(Command,Settings,Sems_Flags)
  cogNew(Others(Command,Settings,Sems_Flags),@Stacks[0])

Pri Others(Command,Settings,Sems_Flags)|t
  ctrA[30..26] := %00100          'Set ctrA for "NCO single-ended"
  ctrA[5..0]   := Blinker         'Set ctra's APIN 
  frqA         := 10*BlinkerScale 'set rate

  dirA[20..16]~~
  dirA[Blinker]~~
  t := cnt                        'initialize timer
  repeat
     if Not(byte[Sems_Flags][1] & FlagMask) 'if flag not set then just loop
        Next
     if Not LockSet(byte[Sems_Flags][2])
        D.Str(string(13,"Others:"))
        D.Dec(byte[Command][0])   
        D.Str(string(","))
        D.Dec(byte[Command][1])   
        LockClr(byte[Sems_Flags][2])

     case byte[Command][0]
         1: 'set the LEDs on P20..P16 per the parameter byte
            outA[20..16] := Byte[Command][1]
         2: 'set the blink rate  for P21
            frqA := byte[Command][1] * BlinkerScale 'set rate
            if frqA == 0
               phsA~             
         192: 'simulate a command that returns some data in 4th and 5th bytes
            'no need for waiting for semaphore
            byte[Command][5] := 50
            byte[Command][6] := 60            
         66: 'simulate a command that returns some data in ALL the 5 bytes
            repeat while Not LockSet(byte[Sems_Flags][0])  'wait for semaphore
            byte[Command][2] := 20
            byte[Command][3] := 30            
            byte[Command][4] := 40
            byte[Command][5] := 50            
            byte[Command][6] := 60
            'clearing the semaphore is done by Main
     byte[Sems_Flags][1] &= !FlagMask   'clear the flag
           