{
  Pots_01.Spin
  Reads the Pots and sends the data to the PST
}
Con                                                   
  _clkmode = xtal1 + pll16x                           
  _xinfreq = 5_000_000                                
 D_TX     = 30
 D_RX     = 31
 D_BAUD   = 115200
 RCPin1    = 3                                            
 RCPin2    = 2                                           
                                                      
Var                                                   
  Long RCTime[2]                                         
                                                      
Obj                                                   
  RC    : "Pots_RCTime"                                
  D     : "SerialMirror"                          
                                                      
Pub Main                                              
  D.Start(D_RX,D_TX,0,D_Baud)                         
  waitcnt(ClkFreq/10+cnt)                              
  repeat
    RC.RCTime(RCPin1,1,@RCTime[0])   'use Pots_RCTime in direct mode ...no cog                                              
    RC.RCTime(RCPin2,1,@RCTime[1])   'to get one-time reading...                                              
    D.Tx(16)                         'clear the PST screen                    
    D.Dec(RCTime[0])                 'output first pot's time value
    D.TX(13)                         'line feed
    D.Dec(RCTime[1])                 'output second pot's time value                
    waitcnt(ClkFreq/2+cnt)                            
                              