//EEPROM_Tester.Bas
//works with Firmware_Main_D.Spin
Port = 8 //change this is as per your system
Main:
  setcommport Port,br115200
  call SendCommand(5,2) 'print EEPROM params to PST
  call SendCommand(5,3)  'print out RAM params to PST
  for i=0 to 11  //using an extra to demo how it returns -1
     call SendCommand(4,i,s)
     print BuffreadI(s,0)," "
  next
  call SendCommand(200,250) 'set the P23 brightness
  call SendCommand(201,0)   'no blinking on P22
  call SendCommand(2,0)     'no blinking on P21
  call SendCommand(5,0,s)   'save to EEPROM
  m = "Saving to the EEPROM failed"
  if SendCommand__Result
     if getstrbyte(s,5) then m = "Saving to the EEPROM succeeded"
  endif
  print m
  print "resetting the propeller . . . wait 3 secs" 
  call SendCommand(255,0) 'reset the Propeller
  delay 3000              'wait for Prop to finish reboot
  print
  call SendCommand(5,2) 'print EEPROM params to PST
  call SendCommand(5,3) 'print out RAM params to PST
  for i=0 to 11
     call SendCommand(4,i,s)
     print BuffreadI(s,0)," "
  next
  print "Resetting factory settings and saving to the EEPROM"
  call SendCommand(5,1) 'restore factory settings
  call SendCommand(5,0) 'save to the EEPROM
  call SendCommand(5,1) 'print RAM params to the PST
  call SendCommand(5,2) 'print EEPROM params to PST
  print "all done"
end
//------------------------------------------
sub SendCommand(C,P,&s)
   serialout C,P
   serbytesin 5,s,x
   if x != 5 then return false
return (x==5)
