//H48C_Tester.Bas
//Works with Firmware_E.Spin
Port =8  //change as per your system
Main:
  fmta = "#0.0000   " \ fmtb = "  #00     "
  setcommport Port,br115200
  v=0
  while true
     call Read_H48C(v,x,y,z,gX,gY,gZ)
     xystring 10,10,v;x-v;y-v;z-v;spaces(20)
     xystring 50,30,Format(gX,fmta),Format(gY,fmta),Format(gZ,fmta)
     xystring 50,50,Format(rtod(atan2(gX,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gY,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gZ,gY)),fmtb)  
     //v = 0    //uncomment this to refresh the vRef all the time
  wend
End
//=================================
sub SendCommand(C,P,&s)
  m = ""
  serialout C,P
  serbytesin 5,s,x
  if x < 5 then m= "Comms Error"
  xystring 500,20,m,spaces(30)  
return (x == 5)
//=================================
sub Read_H48C(&vRef,&xRef,&yRef,&zRef,&xG,&yG,&zG)
  xRef = 0 \ yRef = 0 \ zRef = 0 
  xG =0 \ yG = 0 \ zG = 0
  if vRef == 0
     call SendCommand(70,1,s) //read vRef
     if !SendCommand__Result then return false
     vRef = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
  endif
  call SendCommand(70,0,s) //read the axes
  if !SendCommand__Result then return false
  xRef = (getstrbyte(s,1) << 4) + (getstrbyte(s,2) >>4)
  yRef = ((getstrbyte(s,2)&0x0F) << 8) + getstrbyte(s,3)
  zRef = (getstrbyte(s,4) << 4) + (getstrbyte(s,5) >> 4)
  xG = (xRef-vRef)*.0022  //convert to g-forces
  yG = (yRef-vRef)*.0022
  zG = (zRef-vRef)*.0022
return true
