//TCP_Tester_LAN.Bas
//works through the LAN with the Protocol_Main.Spin
//Over the LAN or Internet
//Port = 16 //change this as per your system
TCPS_IP = "192.168.0.198" //change this to the correct server's IP address
TCPS_Port = 50000  //change this if you change the one in the server
//--------------------------------------------
Main:
  //setcommport Port,br115200
  TCPC_Connect(TCPS_IP,TCPS_Port) //connect to the server
  while true
    //call SendCommand(6,1)  //move the motors forward one step
    call TCP_SendCommand(6,1)  //move the motors forward one step
  wend
End  
//====================================================
sub SendCommand(C,P,&s,&n)
  Serialout C,P   //send the two bytes
  serbytesin 5,s,n
return (n == 5) //return true or false depending on number of arrived bytes
//====================================================
sub TCP_SendCommand(C,P,&s,&n)
  TCPC_Read()                  //read the buffer to clear it
  TCPC_Send(char(C)+char(P))   //send the two bytes
  s = "" \ n=0
  GetTimeOut T \ T += 150      //get the actual timeout limit and add
                               //150 ms to allow for processing
  t=timer()                    //start a timer
  repeat                       //wait for the 5 bytes to arrive with timeout
    if TCPC_BuffCount() != 5 then continue  //if not arrive keep waiting
    s = TCPC_Read() \ n=5     //if arrived get them from the buffer
    break                     //since bytes have arrived then end the loop
  until timer()-t > T         //repeat until timeout
return (n == 5) //return true or false depending on number of arrived bytes
