//Turret_Radar.Bas
//works with Protocol_Main.Bas
//but over the LAN or internet
TCPS_IP = "192.168.0.198" \ TCPS_Port = 50000
tcpc_Connect(TCPS_IP,TCPS_Port)
Port = 0 //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//--------------------------------------------
Main:
  setcommport Port,br115200
  call RadarScreen()
  call Radar()
End
//----------------------------------------
sub Ranger(Angle,&Value)
  C = 192 \ Value=-1 \ m= "Comms Error"
  if Angle < 0 then C = 193
  Angle = Limit(Abs(Angle),0,90)
  //serialout C,Angle
  //serbytesin 5,s,x
  call TCP_SendCommand(C,Angle,s,x)
  if x == 5
    Value = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
    m = spaces(40)
  endif
  xyText 600,10,m,,10,,red
return (x==5)
//---------------------------------------
sub RadarScreen()
  for i=1 to 400 step 50
    arc i,i,800-i,800-i,0,pi(),2,gray
  next
  for i=0 to 180 step 20
    th = dtor(i) \ r = 400
    line r,r,r+cartx(r,th),r-carty(r,th),1,gray
  next
  savescr
return
//----------------------------------------
sub Radar()   
  j=-90 \ i=1
  while true
    call Ranger(j,V)
    if V < 0 then continue
    V *= 400/23000.  \ th = dtor(j-90)
    x = cartx(V,th) \ y = carty(V,th)
    circlewh 400+x-5,400+y-5,10,10,red,red   
    j += i \ if abs(j)==90 then i= -i \ restorescr
  wend
return
//----------------------------------------

