{
   Program_01.Spin

   Sits in a loop waiting for input from RB
   uses that value to set the LEDs on or off
   depending on the value received from RB.

   RB will use the same Commport used to program the
   Propeller. In the Propeller Tool IDE press the
   function key F7 to get a report on what this port
   number is. Make sure to use this number within RB.

   Also in the SPIN program we shall use P30 (TX) and
   P31 (RX) which are the pins on the Propeller connected
   to the programming USB port.

   We shall use FullDuplexSerial.Spin as the Serial driver
   to handle the Serial comms between RB and SPIN.

   Make sure to use F11 (save to EEPROM) not F10 (save to RAM)   
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX    = 30
  RB_RX    = 31
  RB_BAUD  = 115200
OBJ
  RB     : "FullDuplexSerial"
PUB Main
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)  'start the serial driver
  dirA[16..23]~~                   'set pins as output
  repeat                           'endless loop
     outA[23..16] := RB.RX         'assign the pins the value received from RB
