//Program03.Bas
//works with Program_03.Spin, Program_04.Spin, Program_04_B.Spin and Program_05.Spin
Port = 4  //change this as per your system
Main:
    setcommport Port,br115200   //set serial comms
    xystring 10,10,"Click on the checkbox to light up the corresponding LED"
    xystring 10,70,"Press the buttons on the Propeller and see the "+\
                   "corresponding checkbox change"
    for i=0 to 7
       AddCheckBox "DS"+i,60+20*i,40," "   //add checkboxes as bits to form the
    next                                    //number to send
    delay 2000 //wait for the Propeller to be ready
    while true
       x =0
       for i=0 to 7   //form the byte from the individual bits
          if GetCheckBox("DS"+i) then x += 1<<(7-i)
       next   
       serialout x  \ xystring 240,40,"=",x,spaces(20)
       repeat
          CheckSerBuffer x //wait for data in the buffer
       until x
       serin s
       x = ~GetStrByte(s,Length(s))  //value of the last byte and invert it
       for i=0 to 2 
          if GetBit(x,i) 
              circlewh 60+i*40,100,30,30,red,red  //simulate LED on
          else
              circlewh 60+i*40,100,30,30,red      //Simulate LED off
          endif         
       next   
    wend
end

