{
   Program_10_Reader_simple.Spin
   reads the pushbuttons and sets the top 3 bytes
   if a semaphore is available   
}
CON
  Blinker    = 22

Var
  long Stacks[50]

Obj
  D      : "SerialMirror"
  
PUB Start(BytesToSend,Settings,Sems_Flags)
  cogNew(ReadPins(BytesToSend,Settings,Sems_Flags),@Stacks[0])

Pri ReadPins(BytesToSend,Settings,Sems_Flags)|t
  dirA[Blinker]~~
  t := cnt                                   'initialize the timer
  repeat
    if Long[Settings][0] == 0                'if rate is 0 then off
      outA[Blinker]~
    elseif (cnt-t) => Long[Settings][0]      'blinker time out
      !outA[Blinker]                         'toggle the LED
      t :=cnt                                'reset the timer
    if Not LockSet(byte[Sems_Flags][0])      'only set the bytes to send if clear to do so
       byte[BytesToSend][0] := !inA[5] & $01 'read pushbutton inverted to be active high
       byte[BytesToSend][1] := !inA[6] & $01 'read pushbutton inverted to be active high
       byte[BytesToSend][2] := !inA[7] & $01 'read pushbutton inverted to be active high
       'clearing the semaphore is done in Main
       if Not LockSet(byte[Sems_Flags][2])
         D.Str(string(13,"Reader:"))
         D.Dec(byte[BytesToSend][0])   
         D.Str(string(","))
         D.Dec(byte[BytesToSend][1])   
         D.Str(string(","))
         D.Dec(byte[BytesToSend][2])   
         LockClr(byte[Sems_Flags][2])