//Servomotor_12.BAS
//works with Program_12_Main.Spin
Port = 8  //change this as per your system
Main:
  GoSub Initialization
  while true
    K=-1
    if keydown(kc_UArrow) then K = 1      
    if keydown(kc_DArrow) then K = 2  
    if keydown(kc_RArrow) then K = 3
    if keydown(kc_LArrow) then K = 4
    if keydown(kc_Space)  then K = 0
    readmouse x,y,mb
    if mb==1 then Call WhichIsIt(x,y,Ax,Ay,As,K)
    if K > -1 then call DriveMotors(K)
  wend 
end
//---------------------------------------------------------
Initialization:
  setcommport Port,br115200
  data Commands;"Stop","Forward","Backward","Right","Left"
  fnt = "Time New Roman"
  xytext 10,400,"Click on the arrows or press arrow keys",fnt,20,fs_Bold
  xytext 10,440,"Click in the center white square or Space to stop" \
             ,fnt,20,fs_Bold  
  Ax = 200 \ Ay = 200 \ As = 30
  Call DrawArrows(Ax,Ay,As)
Return
//---------------------------------------------------------
sub DrawArrows(Cx,Cy,Scale)
  arrow = "UlulwwssldlU"
  for i=0 to 3
     drawshape RotShape(arrow,i),Cx,Cy,Scale
     floodfill ,,black
  next
return
//---------------------------------------------------------
sub WhichIsIt(x,y,Cx,Cy,Scale,&n)
  f2 = Scale*2 \ f4=Scale*4
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy-f4,Cy-Scale)    then n=1
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy+Scale,Cy+f4)    then n=2
  if within(x,Cx+Scale,Cx+f4)    && within(y,Cy-f2,Cy+f2)       then n=3
  if within(x,Cx-f4,Cx-Scale)    && within(y,Cy-f2,Cy+f2)       then n=4
  if within(x,Cx-Scale,Cx+Scale) && within(y,Cy-Scale,Cy+Scale) then n=0
return
//---------------------------------------------------------
sub DriveMotors(K)
   xystring 10,10,"Last Command =",Commands[K],spaces(20)
   if !vType(_FirstTime)
      data remap;0,6,7,12,13
      _FirstTime = false
   endif
   serialout remap[K],1 //this is the change to make the move
   serbytesin 5,s,x
return

